#A* -------------------------------------------------------------------
#B* This file contains source code for the PyMOL computer program
#C* copyright 1998-2000 by Warren Lyford Delano of DeLano Scientific. 
#D* -------------------------------------------------------------------
#E* It is unlawful to modify or remove this copyright notice.
#F* -------------------------------------------------------------------
#G* Please see the accompanying LICENSE file for further information. 
#H* -------------------------------------------------------------------
#I* Additional authors of this source file include:
#-* 
#-* 
#-*
#Z* -------------------------------------------------------------------

normal = {
'ALA': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '1HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '1HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '1HB'  ,
      } ,
   } ,
'CYM': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'SG'   : { 'symbol' : 'S' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'SG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      } ,
   } ,
'CYS': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HG'   : { 'symbol' : 'H' , } ,
      'SG'   : { 'symbol' : 'S' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'SG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'HG'  , 'SG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HG1'  : 'HG'   ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'CYX': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'SG'   : { 'symbol' : 'S' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'SG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ASP': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OD2'  : { 'symbol' : 'O' , } ,
      'OD1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'OD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( 'OD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ASH': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OD2'  : { 'symbol' : 'O' , } ,
      'OD1'  : { 'symbol' : 'O' , } ,
      'HD2'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'OD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( 'OD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'OD2' , 'HD2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'GLU': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OE1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'OE2'  : { 'symbol' : 'O' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'OE1' , 'CD'   ) : { 'order' : 2 , } ,
      ( 'OE2' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HG1'  : '3HG'  ,
      'HB3'  : '3HB'  ,
      'HG3'  : '3HG'  ,
      'HB1'  : '3HB'  ,
      '1HG'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'GLP': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OE1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      'HE2'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'OE2'  : { 'symbol' : 'O' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'OE1' , 'CD'   ) : { 'order' : 2 , } ,
      ( 'OE2' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'OE2' , 'HE2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HG1'  : '3HG'  ,
      'HB3'  : '3HB'  ,
      'HG3'  : '3HG'  ,
      'HB1'  : '3HB'  ,
      '1HG'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'PHE': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CZ'   : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CE2'  : { 'symbol' : 'C' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      'HZ'   : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( '1HD' , 'CD1'  ) : { 'order' : 1 , } ,
      ( 'CE1' , 'CD1'  ) : { 'order' : 1 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'CZ'  , 'CE1'  ) : { 'order' : 2 , } ,
      ( 'HZ'  , 'CZ'   ) : { 'order' : 1 , } ,
      ( 'CE2' , 'CZ'   ) : { 'order' : 1 , } ,
      ( '2HE' , 'CE2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CE2'  ) : { 'order' : 2 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD1'  : '1HD'  ,
      'HD2'  : '2HD'  ,
      'HE1'  : '1HE'  ,
      'HE2'  : '2HE'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'GLY': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '3HA'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'CA'  , '3HA'  ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HN'   : 'H'    ,
      '1HA'  : '3HA'  ,
      '2HA'  : 'HA'  ,
      'HA1'  : '3HA'  ,
      'HA2'  : 'HA'   ,
      'HA3'  : '3HA'  ,
      } ,
   } ,
'HIP': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      'NE2'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      'ND1'  : { 'symbol' : 'N' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'ND1' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD' , 'ND1'  ) : { 'order' : 1 , } ,
      ( 'CE1' , 'ND1'  ) : { 'order' : 2 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'NE2' , 'CE1'  ) : { 'order' : 1 , } ,
      ( '2HE' , 'NE2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'NE2'  ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD2'  ) : { 'order' : 2 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD1'  : '1HD'  ,
      'HD2'  : '2HD'  ,
      'HE1'  : '1HE'  ,
      'HE2'  : '2HE'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'HIE': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      'NE2'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'ND1'  : { 'symbol' : 'N' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'ND1' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CE1' , 'ND1'  ) : { 'order' : 2 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'NE2' , 'CE1'  ) : { 'order' : 1 , } ,
      ( '2HE' , 'NE2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'NE2'  ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD2'  ) : { 'order' : 2 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HE2'  : '2HE'  ,
      'HE1'  : '1HE'  ,
      'HD2'  : '2HD'  ,
      'HD1'  : '2HD'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'HID': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      'NE2'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'ND1'  : { 'symbol' : 'N' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'ND1' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD' , 'ND1'  ) : { 'order' : 1 , } ,
      ( 'CE1' , 'ND1'  ) : { 'order' : 1 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'NE2' , 'CE1'  ) : { 'order' : 2 , } ,
      ( 'CD2' , 'NE2'  ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD2'  ) : { 'order' : 2 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD1'  : '1HD'  ,
      'HE1'  : '1HE'  ,
      'HD2'  : '2HD'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ILE': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '1HD1' : { 'symbol' : 'H' , } ,
      '3HG1' : { 'symbol' : 'H' , } ,
      'CG2'  : { 'symbol' : 'C' , } ,
      'HB'   : { 'symbol' : 'H' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      '1HG2' : { 'symbol' : 'H' , } ,
      '3HD1' : { 'symbol' : 'H' , } ,
      '2HD1' : { 'symbol' : 'H' , } ,
      '3HG2' : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CG1'  : { 'symbol' : 'C' , } ,
      '2HG1' : { 'symbol' : 'H' , } ,
      '2HG2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'HB'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG2' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '2HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '3HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( 'CG1' , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( '3HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG1'  ) : { 'order' : 1 , } ,
      ( '1HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( '2HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( '3HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HG22' : '2HG2' ,
      'HG23' : '3HG2' ,
      'HD12' : '2HD1' ,
      'HD11' : '1HD1' ,
      '1HG1' : '3HG1' ,
      'HD13' : '3HD1' ,
      'HG13' : '3HG1' ,
      'HG12' : '2HG1' ,
      'HG11' : '3HG1' ,
      'CD'   : 'CD1'  ,
      'HG21' : '1HG2' ,
      'HD1'  : '1HD1' ,
      'HD2'  : '2HD1' ,
      'HD3'  : '3HD1' ,
      } ,
   } ,
'LYS': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      '3HE'  : { 'symbol' : 'H' , } ,
      '3HD'  : { 'symbol' : 'H' , } ,
      'NZ'   : { 'symbol' : 'N' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      'CE'   : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '3HZ'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '1HZ'  : { 'symbol' : 'H' , } ,
      '2HZ'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( '3HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'CE'  , 'CD'   ) : { 'order' : 1 , } ,
      ( '2HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( '3HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( 'NZ'  , 'CE'   ) : { 'order' : 1 , } ,
      ( '1HZ' , 'NZ'   ) : { 'order' : 1 , } ,
      ( '2HZ' , 'NZ'   ) : { 'order' : 1 , } ,
      ( '3HZ' , 'NZ'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HD'  : '3HD'  ,
      'HD1'  : '3HD'  ,
      '1HE'  : '3HE'  ,
      'HZ3'  : '3HZ'  ,
      '1HG'  : '3HG'  ,
      'HZ1'  : '1HZ'  ,
      '1HB'  : '3HB'  ,
      'HG1'  : '3HG'  ,
      'HG3'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HE3'  : '3HE'  ,
      'HZ2'  : '2HZ'  ,
      'HD2'  : '2HD'  ,
      'HD3'  : '3HD'  ,
      'HE1'  : '3HE'  ,
      'HE2'  : '2HE'  ,
      } ,
   } ,
'LEU': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HG'   : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      '3HD2' : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      '3HD1' : { 'symbol' : 'H' , } ,
      '2HD1' : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '1HD1' : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '2HD2' : { 'symbol' : 'H' , } ,
      '1HD2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'HG'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( '2HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( '3HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD2', 'CD2'  ) : { 'order' : 1 , } ,
      ( '2HD2', 'CD2'  ) : { 'order' : 1 , } ,
      ( '3HD2', 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD11' : '1HD1' ,
      'HD12' : '2HD1' ,
      'HD13' : '3HD1' ,
      'HD21' : '1HD2' ,
      'HD23' : '3HD2' ,
      'HD22' : '2HD2' ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'MET': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'SD'   : { 'symbol' : 'S' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      '3HE'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CE'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'SD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CE'  , 'SD'   ) : { 'order' : 1 , } ,
      ( '1HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( '2HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( '3HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HG1'  : '3HG'  ,
      'HB3'  : '3HB'  ,
      'HG3'  : '3HG'  ,
      'HB1'  : '3HB'  ,
      'HE3'  : '3HE'  ,
      'HE2'  : '2HE'  ,
      '1HG'  : '3HG'  ,
      'HE1'  : '1HE'  ,
      'HG2'  : '2HG'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ASN': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '2HD2' : { 'symbol' : 'H' , } ,
      'ND2'  : { 'symbol' : 'N' , } ,
      'OD1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      '1HD2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'OD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( 'ND2' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD2', 'ND2'  ) : { 'order' : 1 , } ,
      ( '2HD2', 'ND2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD21' : '1HD2' ,
      'HD22' : '2HD2' ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'PRO': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      '3HD'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '3HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CB'  , 'CG'   ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'N'   , 'CD'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HD'  : '3HD'  ,
      '1HG'  : '3HG'  ,
      '1HB'  : '3HB'  ,
      'HG1'  : '3HG'  ,
      'HG3'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HD1'  : '3HD'  ,
      'HD2'  : '2HD'  ,
      'HD3'  : '3HD'  ,
      } ,
   } ,
'GLN': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'NE2'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OE1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '1HE2' : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      '2HE2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'OE1' , 'CD'   ) : { 'order' : 2 , } ,
      ( 'NE2' , 'CD'   ) : { 'order' : 1 , } ,
      ( '1HE2', 'NE2'  ) : { 'order' : 1 , } ,
      ( '2HE2', 'NE2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HG1'  : '3HG'  ,
      'HB3'  : '3HB'  ,
      'HG3'  : '3HG'  ,
      'HB1'  : '3HB'  ,
      'HE21' : '1HE2' ,
      'HE22' : '2HE2' ,
      '1HG'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ARG': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HE'   : { 'symbol' : 'H' , } ,
      '1HH1' : { 'symbol' : 'H' , } ,
      '1HH2' : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'NH2'  : { 'symbol' : 'N' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      'NH1'  : { 'symbol' : 'N' , } ,
      '3HD'  : { 'symbol' : 'H' , } ,
      'CZ'   : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'NE'   : { 'symbol' : 'N' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      '2HH1' : { 'symbol' : 'H' , } ,
      '2HH2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( '3HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'NE'  , 'CD'   ) : { 'order' : 1 , } ,
      ( 'HE'  , 'NE'   ) : { 'order' : 1 , } ,
      ( 'CZ'  , 'NE'   ) : { 'order' : 1 , } ,
      ( 'NH1' , 'CZ'   ) : { 'order' : 2 , } ,
      ( '1HH1', 'NH1'  ) : { 'order' : 1 , } ,
      ( '2HH1', 'NH1'  ) : { 'order' : 1 , } ,
      ( 'NH2' , 'CZ'   ) : { 'order' : 1 , } ,
      ( '1HH2', 'NH2'  ) : { 'order' : 1 , } ,
      ( '2HH2', 'NH2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HG'  : '3HG'  ,
      '1HD'  : '3HD'  ,
      'HH12' : '2HH1' ,
      'HH21' : '1HH2' ,
      'HH22' : '2HH2' ,
      'HG1'  : '3HG'  ,
      'HH11' : '1HH1' ,
      'HG3'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      '1HB'  : '3HB'  ,
      'HD1'  : '3HD'  ,
      'HD2'  : '2HD'  ,
      'HD3'  : '3HD'  ,
      } ,
   } ,
'SER': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HG'   : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'OG'   : { 'symbol' : 'O' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'OG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'HG'  , 'OG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HG1'  : 'HG'   ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'THR': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'OG1'  : { 'symbol' : 'O' , } ,
      'CG2'  : { 'symbol' : 'C' , } ,
      '3HG2' : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'HB'   : { 'symbol' : 'H' , } ,
      '1HG'  : { 'symbol' : 'H' , } ,
      '1HG2' : { 'symbol' : 'H' , } ,
      '2HG2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'HB'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG2' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '2HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '3HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( 'OG1' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG' , 'OG1'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HG1'  : '1HG'  ,
      'HG22' : '2HG2' ,
      'HG23' : '3HG2' ,
      'HG21' : '1HG2' ,
      } ,
   } ,
'VAL': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CG2'  : { 'symbol' : 'C' , } ,
      '3HG2' : { 'symbol' : 'H' , } ,
      '3HG1' : { 'symbol' : 'H' , } ,
      'HB'   : { 'symbol' : 'H' , } ,
      '1HG1' : { 'symbol' : 'H' , } ,
      'CG1'  : { 'symbol' : 'C' , } ,
      '1HG2' : { 'symbol' : 'H' , } ,
      '2HG1' : { 'symbol' : 'H' , } ,
      '2HG2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'HB'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG1' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( '2HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( '3HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( 'CG2' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '2HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '3HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HG22' : '2HG2' ,
      'HG12' : '2HG1' ,
      'HG13' : '3HG1' ,
      'HG23' : '3HG2' ,
      'HG11' : '1HG1' ,
      'HG21' : '1HG2' ,
      } ,
   } ,
'TRP': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'NE1'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CZ3'  : { 'symbol' : 'C' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      'CE3'  : { 'symbol' : 'C' , } ,
      'CH2'  : { 'symbol' : 'C' , } ,
      '2HH'  : { 'symbol' : 'H' , } ,
      '3HE'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '3HZ'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CZ2'  : { 'symbol' : 'C' , } ,
      'CE2'  : { 'symbol' : 'C' , } ,
      '2HZ'  : { 'symbol' : 'H' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( '1HD' , 'CD1'  ) : { 'order' : 1 , } ,
      ( 'NE1' , 'CD1'  ) : { 'order' : 1 , } ,
      ( '1HE' , 'NE1'  ) : { 'order' : 1 , } ,
      ( 'CE2' , 'NE1'  ) : { 'order' : 1 , } ,
      ( 'CZ2' , 'CE2'  ) : { 'order' : 1 , } ,
      ( '2HZ' , 'CZ2'  ) : { 'order' : 1 , } ,
      ( 'CH2' , 'CZ2'  ) : { 'order' : 2 , } ,
      ( '2HH' , 'CH2'  ) : { 'order' : 1 , } ,
      ( 'CZ3' , 'CH2'  ) : { 'order' : 1 , } ,
      ( '3HZ' , 'CZ3'  ) : { 'order' : 1 , } ,
      ( 'CE3' , 'CZ3'  ) : { 'order' : 2 , } ,
      ( '3HE' , 'CE3'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CE3'  ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CE2' , 'CD2'  ) : { 'order' : 2 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HZ3'  : '3HZ'  ,
      '1HZ'  : '3HZ'  ,
      'HZ2'  : '2HZ'  ,
      'HD1'  : '1HD'  ,
      'HE1'  : '1HE'  ,
      'HE3'  : '3HE'  ,
      'HH2'  : '2HH'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'TYR': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      'HH'   : { 'symbol' : 'H' , } ,
      'CZ'   : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'OH'   : { 'symbol' : 'O' , } ,
      'CE2'  : { 'symbol' : 'C' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( '1HD' , 'CD1'  ) : { 'order' : 1 , } ,
      ( 'CE1' , 'CD1'  ) : { 'order' : 1 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'CZ'  , 'CE1'  ) : { 'order' : 2 , } ,
      ( 'OH'  , 'CZ'   ) : { 'order' : 1 , } ,
      ( 'HH'  , 'OH'   ) : { 'order' : 1 , } ,
      ( 'CE2' , 'CZ'   ) : { 'order' : 1 , } ,
      ( '2HE' , 'CE2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CE2'  ) : { 'order' : 2 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HA2'  : 'HA'   ,
      'HN'   : 'H'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD1'  : '1HD'  ,
      'HD2'  : '2HD'  ,
      'HE1'  : '1HE'  ,
      'HE2'  : '2HE'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'NME': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      '3HH3' : { 'symbol' : 'H' , } ,
      '1HH3' : { 'symbol' : 'H' , } ,
      'CH3'  : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      '2HH3' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CH3'  ) : { 'order' : 1 , } ,
      ( 'CH3' , '1HH3' ) : { 'order' : 1 , } ,
      ( 'CH3' , '2HH3' ) : { 'order' : 1 , } ,
      ( 'CH3' , '3HH3' ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'HH32' : '2HH3' ,
      'HH33' : '3HH3' ,
      'HH31' : '1HH3' ,
      'C01'  : 'CH3'  ,
      'CA'   : 'CH3'  ,
      'N01'  : 'N'    ,
      'H01'  : 'H'    ,
      'HN'   : 'H'    ,      
      'H02'  : '1HH3' ,      
      'H03'  : '2HH3' ,
      'H04'  : '3HH3' ,
      '1HA'  : '1HH3' ,      
      '2HA'  : '2HH3' ,
      '3HA'  : '3HH3' ,
      } ,
   } ,
'ACE': {
   'atoms' : {
      'O'    : { 'symbol' : 'O' , } ,
      '3HH3' : { 'symbol' : 'H' , } ,
      '1HH3' : { 'symbol' : 'H' , } ,
      'CH3'  : { 'symbol' : 'C' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HH3' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'CH3' , '1HH3' ) : { 'order' : 1 , } ,
      ( 'CH3' , '2HH3' ) : { 'order' : 1 , } ,
      ( 'CH3' , '3HH3' ) : { 'order' : 1 , } ,
      ( 'CH3' , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      } ,
   'aliases' : {
      'HH32' : '2HH3' ,
      'HH33' : '3HH3' ,
      'HH31' : '1HH3' ,
      'CA'   : 'CH3'  ,
      '1HA'  : '2HH3' ,
      '2HA'  : '3HH3' ,
      '3HA'  : '1HH3' ,
      'CA'   : 'CH3'  ,
      } ,
   } ,
}
n_terminal = {
'ALA': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '1HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '1HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '1HB'  ,
      } ,
   } ,
'CYS': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HG'   : { 'symbol' : 'H' , } ,
      'SG'   : { 'symbol' : 'S' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'SG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'HG'  , 'SG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HG1'  : 'HG'   ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'CYX': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'SG'   : { 'symbol' : 'S' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'SG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ASP': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OD2'  : { 'symbol' : 'O' , } ,
      'OD1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'OD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( 'OD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ASH': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OD2'  : { 'symbol' : 'O' , } ,
      'OD1'  : { 'symbol' : 'O' , } ,
      'HD2'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'OD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( 'OD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'OD2' , 'HD2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'GLU': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OE1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'OE2'  : { 'symbol' : 'O' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'OE1' , 'CD'   ) : { 'order' : 2 , } ,
      ( 'OE2' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HG1'  : '3HG'  ,
      'HB3'  : '3HB'  ,
      'HG3'  : '3HG'  ,
      'HB1'  : '3HB'  ,
      '1HG'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'GLP': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OE1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      'HE2'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'OE2'  : { 'symbol' : 'O' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'OE1' , 'CD'   ) : { 'order' : 2 , } ,
      ( 'OE2' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'OE2' , 'HE2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HG1'  : '3HG'  ,
      'HB3'  : '3HB'  ,
      'HG3'  : '3HG'  ,
      'HB1'  : '3HB'  ,
      '1HG'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'PHE': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CZ'   : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CE2'  : { 'symbol' : 'C' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      'HZ'   : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( '1HD' , 'CD1'  ) : { 'order' : 1 , } ,
      ( 'CE1' , 'CD1'  ) : { 'order' : 1 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'CZ'  , 'CE1'  ) : { 'order' : 2 , } ,
      ( 'HZ'  , 'CZ'   ) : { 'order' : 1 , } ,
      ( 'CE2' , 'CZ'   ) : { 'order' : 1 , } ,
      ( '2HE' , 'CE2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CE2'  ) : { 'order' : 2 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD1'  : '1HD'  ,
      'HD2'  : '2HD'  ,
      'HE1'  : '1HE'  ,
      'HE2'  : '2HE'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'GLY': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '3HA'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'CA'  , '3HA'  ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      '1HA'  : '3HA'  ,
      '2HA'  : 'HA'   ,
      'HA1'  : '3HA'  ,
      'HA2'  : 'HA'   ,      
      'HA3'  : '3HA'  ,
      } ,
   } ,
'HIP': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      'NE2'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      'ND1'  : { 'symbol' : 'N' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'ND1' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD' , 'ND1'  ) : { 'order' : 1 , } ,
      ( 'CE1' , 'ND1'  ) : { 'order' : 2 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'NE2' , 'CE1'  ) : { 'order' : 1 , } ,
      ( '2HE' , 'NE2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'NE2'  ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD2'  ) : { 'order' : 2 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD1'  : '1HD'  ,
      'HD2'  : '2HD'  ,
      'HE1'  : '1HE'  ,
      'HE2'  : '2HE'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'HIE': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      'NE2'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'ND1'  : { 'symbol' : 'N' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'ND1' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CE1' , 'ND1'  ) : { 'order' : 2 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'NE2' , 'CE1'  ) : { 'order' : 1 , } ,
      ( '2HE' , 'NE2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'NE2'  ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD2'  ) : { 'order' : 2 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HE2'  : '2HE'  ,
      'HE1'  : '1HE'  ,
      'HD1'  : '2HD'  ,
      'HD2'  : '2HD'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'HID': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      'NE2'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'ND1'  : { 'symbol' : 'N' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'ND1' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD' , 'ND1'  ) : { 'order' : 1 , } ,
      ( 'CE1' , 'ND1'  ) : { 'order' : 1 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'NE2' , 'CE1'  ) : { 'order' : 2 , } ,
      ( 'CD2' , 'NE2'  ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD2'  ) : { 'order' : 2 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD1'  : '1HD'  ,
      'HE1'  : '1HE'  ,
      'HD2'  : '2HD'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ILE': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '1HD1' : { 'symbol' : 'H' , } ,
      '3HG1' : { 'symbol' : 'H' , } ,
      'CG2'  : { 'symbol' : 'C' , } ,
      'HB'   : { 'symbol' : 'H' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      '1HG2' : { 'symbol' : 'H' , } ,
      '3HD1' : { 'symbol' : 'H' , } ,
      '2HD1' : { 'symbol' : 'H' , } ,
      '3HG2' : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CG1'  : { 'symbol' : 'C' , } ,
      '2HG1' : { 'symbol' : 'H' , } ,
      '2HG2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'HB'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG2' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '2HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '3HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( 'CG1' , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( '3HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG1'  ) : { 'order' : 1 , } ,
      ( '1HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( '2HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( '3HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HG22' : '2HG2' ,
      'HG23' : '3HG2' ,
      'HD12' : '2HD1' ,
      'HD11' : '1HD1' ,
      '1HG1' : '3HG1' ,
      'HD13' : '3HD1' ,
      'HG13' : '3HG1' ,
      'HG12' : '2HG1' ,
      'HG11' : '3HG1' ,
      'CD'   : 'CD1'  ,
      'HG21' : '1HG2' ,
      'HD1'  : '1HD1' ,
      'HD2'  : '2HD1' ,
      'HD3'  : '3HD1' ,
      } ,
   } ,
'LYS': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      '3HE'  : { 'symbol' : 'H' , } ,
      '3HD'  : { 'symbol' : 'H' , } ,
      'NZ'   : { 'symbol' : 'N' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      'CE'   : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '3HZ'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '1HZ'  : { 'symbol' : 'H' , } ,
      '2HZ'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( '3HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'CE'  , 'CD'   ) : { 'order' : 1 , } ,
      ( '2HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( '3HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( 'NZ'  , 'CE'   ) : { 'order' : 1 , } ,
      ( '1HZ' , 'NZ'   ) : { 'order' : 1 , } ,
      ( '2HZ' , 'NZ'   ) : { 'order' : 1 , } ,
      ( '3HZ' , 'NZ'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HD'  : '3HD'  ,
      'HD1'  : '3HD'  ,
      '1HE'  : '3HE'  ,
      'HZ3'  : '3HZ'  ,
      '1HG'  : '3HG'  ,
      'HZ1'  : '1HZ'  ,
      '1HB'  : '3HB'  ,
      'HG1'  : '3HG'  ,
      'HG3'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HE3'  : '3HE'  ,
      'HZ2'  : '2HZ'  ,
      'HD2'  : '2HD'  ,
      'HD3'  : '3HD'  ,
      'HE1'  : '3HE'  ,
      'HE2'  : '2HE'  ,
      } ,
   } ,
'LEU': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HG'   : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      '3HD2' : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      '3HD1' : { 'symbol' : 'H' , } ,
      '2HD1' : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '1HD1' : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '2HD2' : { 'symbol' : 'H' , } ,
      '1HD2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'HG'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( '2HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( '3HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD2', 'CD2'  ) : { 'order' : 1 , } ,
      ( '2HD2', 'CD2'  ) : { 'order' : 1 , } ,
      ( '3HD2', 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD11' : '1HD1' ,
      'HD12' : '2HD1' ,
      'HD13' : '3HD1' ,
      'HD21' : '1HD2' ,
      'HD23' : '3HD2' ,
      'HD22' : '2HD2' ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'MET': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'SD'   : { 'symbol' : 'S' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      '3HE'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CE'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'SD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CE'  , 'SD'   ) : { 'order' : 1 , } ,
      ( '1HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( '2HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( '3HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HG1'  : '3HG'  ,
      'HB3'  : '3HB'  ,
      'HG3'  : '3HG'  ,
      'HB1'  : '3HB'  ,
      'HE3'  : '3HE'  ,
      'HE2'  : '2HE'  ,
      '1HG'  : '3HG'  ,
      'HE1'  : '1HE'  ,
      'HG2'  : '2HG'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ASN': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '2HD2' : { 'symbol' : 'H' , } ,
      'ND2'  : { 'symbol' : 'N' , } ,
      'OD1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      '1HD2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'OD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( 'ND2' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD2', 'ND2'  ) : { 'order' : 1 , } ,
      ( '2HD2', 'ND2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD21' : '1HD2' ,
      'HD22' : '2HD2' ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'PRO': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2H'   : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '3H'   : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      '3HD'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '2H'   ) : { 'order' : 1 , } ,
      ( 'N'   , '3H'   ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '3HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CB'  , 'CG'   ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'N'   , 'CD'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '3H'  ,
      '2H'   : '2H'  ,
      '3H'   : '3H'  ,      
      'H3'   : '3H'   ,
      'H2'   : '2H'   ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HD'  : '3HD'  ,
      '1HG'  : '3HG'  ,
      '1HB'  : '3HB'  ,
      'HG1'  : '3HG'  ,
      'HG3'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HD1'  : '3HD'  ,
      'HD2'  : '2HD'  ,
      'HD3'  : '3HD'  ,
      } ,
   } ,
'GLN': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'NE2'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OE1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '1HE2' : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      '2HE2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'OE1' , 'CD'   ) : { 'order' : 2 , } ,
      ( 'NE2' , 'CD'   ) : { 'order' : 1 , } ,
      ( '1HE2', 'NE2'  ) : { 'order' : 1 , } ,
      ( '2HE2', 'NE2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HG1'  : '3HG'  ,
      'HB3'  : '3HB'  ,
      'HG3'  : '3HG'  ,
      'HB1'  : '3HB'  ,
      'HE21' : '1HE2' ,
      'HE22' : '2HE2' ,
      '1HG'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ARG': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HE'   : { 'symbol' : 'H' , } ,
      '1HH1' : { 'symbol' : 'H' , } ,
      '1HH2' : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'NH2'  : { 'symbol' : 'N' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      'NH1'  : { 'symbol' : 'N' , } ,
      '3HD'  : { 'symbol' : 'H' , } ,
      'CZ'   : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'NE'   : { 'symbol' : 'N' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      '2HH1' : { 'symbol' : 'H' , } ,
      '2HH2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( '3HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'NE'  , 'CD'   ) : { 'order' : 1 , } ,
      ( 'HE'  , 'NE'   ) : { 'order' : 1 , } ,
      ( 'CZ'  , 'NE'   ) : { 'order' : 1 , } ,
      ( 'NH1' , 'CZ'   ) : { 'order' : 2 , } ,
      ( '1HH1', 'NH1'  ) : { 'order' : 1 , } ,
      ( '2HH1', 'NH1'  ) : { 'order' : 1 , } ,
      ( 'NH2' , 'CZ'   ) : { 'order' : 1 , } ,
      ( '1HH2', 'NH2'  ) : { 'order' : 1 , } ,
      ( '2HH2', 'NH2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HG'  : '3HG'  ,
      '1HD'  : '3HD'  ,
      'HH12' : '2HH1' ,
      'HH21' : '1HH2' ,
      'HH22' : '2HH2' ,
      'HG1'  : '3HG'  ,
      'HH11' : '1HH1' ,
      'HG3'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      '1HB'  : '3HB'  ,
      'HD1'  : '3HD'  ,
      'HD2'  : '2HD'  ,
      'HD3'  : '3HD'  ,
      } ,
   } ,
'SER': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HG'   : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'OG'   : { 'symbol' : 'O' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'OG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'HG'  , 'OG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HG1'  : 'HG'   ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'THR': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'OG1'  : { 'symbol' : 'O' , } ,
      'CG2'  : { 'symbol' : 'C' , } ,
      '3HG2' : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'HB'   : { 'symbol' : 'H' , } ,
      '1HG'  : { 'symbol' : 'H' , } ,
      '1HG2' : { 'symbol' : 'H' , } ,
      '2HG2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'HB'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG2' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '2HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '3HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( 'OG1' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG' , 'OG1'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HG1'  : '1HG'  ,
      'HG22' : '2HG2' ,
      'HG23' : '3HG2' ,
      'HG21' : '1HG2' ,
      } ,
   } ,
'VAL': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CG2'  : { 'symbol' : 'C' , } ,
      '3HG2' : { 'symbol' : 'H' , } ,
      '3HG1' : { 'symbol' : 'H' , } ,
      'HB'   : { 'symbol' : 'H' , } ,
      '1HG1' : { 'symbol' : 'H' , } ,
      'CG1'  : { 'symbol' : 'C' , } ,
      '1HG2' : { 'symbol' : 'H' , } ,
      '2HG1' : { 'symbol' : 'H' , } ,
      '2HG2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'HB'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG1' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( '2HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( '3HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( 'CG2' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '2HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '3HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HG22' : '2HG2' ,
      'HG12' : '2HG1' ,
      'HG13' : '3HG1' ,
      'HG23' : '3HG2' ,
      'HG11' : '1HG1' ,
      'HG21' : '1HG2' ,
      } ,
   } ,
'TRP': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'NE1'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CZ3'  : { 'symbol' : 'C' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      'CE3'  : { 'symbol' : 'C' , } ,
      'CH2'  : { 'symbol' : 'C' , } ,
      '2HH'  : { 'symbol' : 'H' , } ,
      '3HE'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '3HZ'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CZ2'  : { 'symbol' : 'C' , } ,
      'CE2'  : { 'symbol' : 'C' , } ,
      '2HZ'  : { 'symbol' : 'H' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( '1HD' , 'CD1'  ) : { 'order' : 1 , } ,
      ( 'NE1' , 'CD1'  ) : { 'order' : 1 , } ,
      ( '1HE' , 'NE1'  ) : { 'order' : 1 , } ,
      ( 'CE2' , 'NE1'  ) : { 'order' : 1 , } ,
      ( 'CZ2' , 'CE2'  ) : { 'order' : 1 , } ,
      ( '2HZ' , 'CZ2'  ) : { 'order' : 1 , } ,
      ( 'CH2' , 'CZ2'  ) : { 'order' : 2 , } ,
      ( '2HH' , 'CH2'  ) : { 'order' : 1 , } ,
      ( 'CZ3' , 'CH2'  ) : { 'order' : 1 , } ,
      ( '3HZ' , 'CZ3'  ) : { 'order' : 1 , } ,
      ( 'CE3' , 'CZ3'  ) : { 'order' : 2 , } ,
      ( '3HE' , 'CE3'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CE3'  ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CE2' , 'CD2'  ) : { 'order' : 2 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HZ3'  : '3HZ'  ,
      '1HZ'  : '3HZ'  ,
      'HZ2'  : '2HZ'  ,
      'HD1'  : '1HD'  ,
      'HE1'  : '1HE'  ,
      'HE3'  : '3HE'  ,
      'HH2'  : '2HH'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'TYR': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      '2HT'  : { 'symbol' : 'H' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      '1HT'  : { 'symbol' : 'H' , } ,
      '3HT'  : { 'symbol' : 'H' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      'HH'   : { 'symbol' : 'H' , } ,
      'CZ'   : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'OH'   : { 'symbol' : 'O' , } ,
      'CE2'  : { 'symbol' : 'C' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , '1HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '2HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , '3HT'  ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( '1HD' , 'CD1'  ) : { 'order' : 1 , } ,
      ( 'CE1' , 'CD1'  ) : { 'order' : 1 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'CZ'  , 'CE1'  ) : { 'order' : 2 , } ,
      ( 'OH'  , 'CZ'   ) : { 'order' : 1 , } ,
      ( 'HH'  , 'OH'   ) : { 'order' : 1 , } ,
      ( 'CE2' , 'CZ'   ) : { 'order' : 1 , } ,
      ( '2HE' , 'CE2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CE2'  ) : { 'order' : 2 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      '1H'   : '1HT'  ,
      '2H'   : '2HT'  ,
      '3H'   : '3HT'  ,      
      'HT1'  : '1HT'  ,
      'HT2'  : '2HT'  ,
      'HT3'  : '3HT'  ,
      'H1'   : '1HT'  ,
      'H3'   : '3HT'  ,
      'H2'   : '2HT'  ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD1'  : '1HD'  ,
      'HD2'  : '2HD'  ,
      'HE1'  : '1HE'  ,
      'HE2'  : '2HE'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
}

c_terminal = {
'ALA': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '1HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '1HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '1HB'  ,
      } ,
   } ,
'CYS': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HG'   : { 'symbol' : 'H' , } ,
      'SG'   : { 'symbol' : 'S' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'SG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'HG'  , 'SG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HG1'  : 'HG'   ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'CYX': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'SG'   : { 'symbol' : 'S' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'SG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ASP': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OD2'  : { 'symbol' : 'O' , } ,
      'OD1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'OD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( 'OD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ASH': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OD2'  : { 'symbol' : 'O' , } ,
      'OD1'  : { 'symbol' : 'O' , } ,
      'HD2'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'OD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( 'OD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'OD2' , 'HD2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'GLU': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OE1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'OE2'  : { 'symbol' : 'O' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'OE1' , 'CD'   ) : { 'order' : 2 , } ,
      ( 'OE2' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HG1'  : '3HG'  ,
      'HB3'  : '3HB'  ,
      'HG3'  : '3HG'  ,
      'HB1'  : '3HB'  ,
      '1HG'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'GLP': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OE1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      'HE2'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'OE2'  : { 'symbol' : 'O' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'OE1' , 'CD'   ) : { 'order' : 2 , } ,
      ( 'OE2' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'OE2' , 'HE2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HG1'  : '3HG'  ,
      'HB3'  : '3HB'  ,
      'HG3'  : '3HG'  ,
      'HB1'  : '3HB'  ,
      '1HG'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'PHE': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CZ'   : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CE2'  : { 'symbol' : 'C' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      'HZ'   : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( '1HD' , 'CD1'  ) : { 'order' : 1 , } ,
      ( 'CE1' , 'CD1'  ) : { 'order' : 1 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'CZ'  , 'CE1'  ) : { 'order' : 2 , } ,
      ( 'HZ'  , 'CZ'   ) : { 'order' : 1 , } ,
      ( 'CE2' , 'CZ'   ) : { 'order' : 1 , } ,
      ( '2HE' , 'CE2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CE2'  ) : { 'order' : 2 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD1'  : '1HD'  ,
      'HD2'  : '2HD'  ,
      'HE1'  : '1HE'  ,
      'HE2'  : '2HE'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'GLY': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '3HA'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( 'CA'  , '3HA'  ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      '1HA'  : '3HA'  ,
      '2HA'  : 'HA'   ,
      'HA1'  : '3HA'  ,
      'HA2'  : 'HA'   ,
      'HA3'  : '3HA'  ,
      } ,
   } ,
'HIP': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      'NE2'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      'ND1'  : { 'symbol' : 'N' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'ND1' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD' , 'ND1'  ) : { 'order' : 1 , } ,
      ( 'CE1' , 'ND1'  ) : { 'order' : 2 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'NE2' , 'CE1'  ) : { 'order' : 1 , } ,
      ( '2HE' , 'NE2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'NE2'  ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD2'  ) : { 'order' : 2 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD1'  : '1HD'  ,
      'HD2'  : '2HD'  ,
      'HE1'  : '1HE'  ,
      'HE2'  : '2HE'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'HIE': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      'NE2'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'ND1'  : { 'symbol' : 'N' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'ND1' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CE1' , 'ND1'  ) : { 'order' : 2 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'NE2' , 'CE1'  ) : { 'order' : 1 , } ,
      ( '2HE' , 'NE2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'NE2'  ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD2'  ) : { 'order' : 2 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HE2'  : '2HE'  ,
      'HE1'  : '1HE'  ,
      'HD2'  : '2HD'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'HID': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      'NE2'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'ND1'  : { 'symbol' : 'N' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'ND1' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD' , 'ND1'  ) : { 'order' : 1 , } ,
      ( 'CE1' , 'ND1'  ) : { 'order' : 1 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'NE2' , 'CE1'  ) : { 'order' : 2 , } ,
      ( 'CD2' , 'NE2'  ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD2'  ) : { 'order' : 2 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD1'  : '1HD'  ,
      'HE1'  : '1HE'  ,
      'HD2'  : '2HD'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ILE': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '1HD1' : { 'symbol' : 'H' , } ,
      '3HG1' : { 'symbol' : 'H' , } ,
      'CG2'  : { 'symbol' : 'C' , } ,
      'HB'   : { 'symbol' : 'H' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      '1HG2' : { 'symbol' : 'H' , } ,
      '3HD1' : { 'symbol' : 'H' , } ,
      '2HD1' : { 'symbol' : 'H' , } ,
      '3HG2' : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CG1'  : { 'symbol' : 'C' , } ,
      '2HG1' : { 'symbol' : 'H' , } ,
      '2HG2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( 'HB'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG2' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '2HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '3HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( 'CG1' , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( '3HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG1'  ) : { 'order' : 1 , } ,
      ( '1HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( '2HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( '3HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HG22' : '2HG2' ,
      'HG23' : '3HG2' ,
      'HD12' : '2HD1' ,
      'HD11' : '1HD1' ,
      '1HG1' : '3HG1' ,
      'HD13' : '3HD1' ,
      'HG13' : '3HG1' ,
      'HG12' : '2HG1' ,
      'HG11' : '3HG1' ,
      'CD'   : 'CD1'  ,
      'HG21' : '1HG2' ,
      'HD1'  : '1HD1' ,
      'HD2'  : '2HD1' ,
      'HD3'  : '3HD1' ,
      } ,
   } ,
'LYS': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      '3HE'  : { 'symbol' : 'H' , } ,
      '3HD'  : { 'symbol' : 'H' , } ,
      'NZ'   : { 'symbol' : 'N' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      'CE'   : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '3HZ'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '1HZ'  : { 'symbol' : 'H' , } ,
      '2HZ'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( '3HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'CE'  , 'CD'   ) : { 'order' : 1 , } ,
      ( '2HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( '3HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( 'NZ'  , 'CE'   ) : { 'order' : 1 , } ,
      ( '1HZ' , 'NZ'   ) : { 'order' : 1 , } ,
      ( '2HZ' , 'NZ'   ) : { 'order' : 1 , } ,
      ( '3HZ' , 'NZ'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HD'  : '3HD'  ,
      'HD1'  : '3HD'  ,
      '1HE'  : '3HE'  ,
      'HZ3'  : '3HZ'  ,
      '1HG'  : '3HG'  ,
      'HZ1'  : '1HZ'  ,
      '1HB'  : '3HB'  ,
      'HG1'  : '3HG'  ,
      'HG3'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HE3'  : '3HE'  ,
      'HZ2'  : '2HZ'  ,
      'HD2'  : '2HD'  ,
      'HD3'  : '3HD'  ,
      'HE1'  : '3HE'  ,
      'HE2'  : '2HE'  ,
      } ,
   } ,
'LEU': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HG'   : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      '3HD2' : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      '3HD1' : { 'symbol' : 'H' , } ,
      '2HD1' : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '1HD1' : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '2HD2' : { 'symbol' : 'H' , } ,
      '1HD2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'HG'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( '2HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( '3HD1', 'CD1'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD2', 'CD2'  ) : { 'order' : 1 , } ,
      ( '2HD2', 'CD2'  ) : { 'order' : 1 , } ,
      ( '3HD2', 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD11' : '1HD1' ,
      'HD12' : '2HD1' ,
      'HD13' : '3HD1' ,
      'HD21' : '1HD2' ,
      'HD23' : '3HD2' ,
      'HD22' : '2HD2' ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'MET': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'SD'   : { 'symbol' : 'S' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      '3HE'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CE'   : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'SD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CE'  , 'SD'   ) : { 'order' : 1 , } ,
      ( '1HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( '2HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( '3HE' , 'CE'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HG1'  : '3HG'  ,
      'HB3'  : '3HB'  ,
      'HG3'  : '3HG'  ,
      'HB1'  : '3HB'  ,
      'HE3'  : '3HE'  ,
      'HE2'  : '2HE'  ,
      '1HG'  : '3HG'  ,
      'HE1'  : '1HE'  ,
      'HG2'  : '2HG'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ASN': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '2HD2' : { 'symbol' : 'H' , } ,
      'ND2'  : { 'symbol' : 'N' , } ,
      'OD1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      '1HD2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'OD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( 'ND2' , 'CG'   ) : { 'order' : 1 , } ,
      ( '1HD2', 'ND2'  ) : { 'order' : 1 , } ,
      ( '2HD2', 'ND2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD21' : '1HD2' ,
      'HD22' : '2HD2' ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'PRO': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      '3HD'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '3HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CB'  , 'CG'   ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'N'   , 'CD'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HD'  : '3HD'  ,
      '1HG'  : '3HG'  ,
      '1HB'  : '3HB'  ,
      'HG1'  : '3HG'  ,
      'HG3'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HD1'  : '3HD'  ,
      'HD2'  : '2HD'  ,
      'HD3'  : '3HD'  ,
      } ,
   } ,
'GLN': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'NE2'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'OE1'  : { 'symbol' : 'O' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '1HE2' : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      '2HE2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( 'OE1' , 'CD'   ) : { 'order' : 2 , } ,
      ( 'NE2' , 'CD'   ) : { 'order' : 1 , } ,
      ( '1HE2', 'NE2'  ) : { 'order' : 1 , } ,
      ( '2HE2', 'NE2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HG1'  : '3HG'  ,
      'HB3'  : '3HB'  ,
      'HG3'  : '3HG'  ,
      'HB1'  : '3HB'  ,
      'HE21' : '1HE2' ,
      'HE22' : '2HE2' ,
      '1HG'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'ARG': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HE'   : { 'symbol' : 'H' , } ,
      '1HH1' : { 'symbol' : 'H' , } ,
      '1HH2' : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '2HG'  : { 'symbol' : 'H' , } ,
      'NH2'  : { 'symbol' : 'N' , } ,
      '3HG'  : { 'symbol' : 'H' , } ,
      'NH1'  : { 'symbol' : 'N' , } ,
      '3HD'  : { 'symbol' : 'H' , } ,
      'CZ'   : { 'symbol' : 'C' , } ,
      'CD'   : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'NE'   : { 'symbol' : 'N' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      '2HH1' : { 'symbol' : 'H' , } ,
      '2HH2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( '2HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( '3HG' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CD'  , 'CG'   ) : { 'order' : 1 , } ,
      ( '2HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( '3HD' , 'CD'   ) : { 'order' : 1 , } ,
      ( 'NE'  , 'CD'   ) : { 'order' : 1 , } ,
      ( 'HE'  , 'NE'   ) : { 'order' : 1 , } ,
      ( 'CZ'  , 'NE'   ) : { 'order' : 1 , } ,
      ( 'NH1' , 'CZ'   ) : { 'order' : 2 , } ,
      ( '1HH1', 'NH1'  ) : { 'order' : 1 , } ,
      ( '2HH1', 'NH1'  ) : { 'order' : 1 , } ,
      ( 'NH2' , 'CZ'   ) : { 'order' : 1 , } ,
      ( '1HH2', 'NH2'  ) : { 'order' : 1 , } ,
      ( '2HH2', 'NH2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      '1HG'  : '3HG'  ,
      '1HD'  : '3HD'  ,
      'HH12' : '2HH1' ,
      'HH21' : '1HH2' ,
      'HH22' : '2HH2' ,
      'HG1'  : '3HG'  ,
      'HH11' : '1HH1' ,
      'HG3'  : '3HG'  ,
      'HG2'  : '2HG'  ,
      '1HB'  : '3HB'  ,
      'HD1'  : '3HD'  ,
      'HD2'  : '2HD'  ,
      'HD3'  : '3HD'  ,
      } ,
   } ,
'SER': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'HG'   : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'OG'   : { 'symbol' : 'O' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'OG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'HG'  , 'OG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HG1'  : 'HG'   ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HB2'  : '2HB'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'THR': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'OG1'  : { 'symbol' : 'O' , } ,
      'CG2'  : { 'symbol' : 'C' , } ,
      '3HG2' : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'HB'   : { 'symbol' : 'H' , } ,
      '1HG'  : { 'symbol' : 'H' , } ,
      '1HG2' : { 'symbol' : 'H' , } ,
      '2HG2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( 'HB'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG2' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '2HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '3HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( 'OG1' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG' , 'OG1'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HG1'  : '1HG'  ,
      'HG22' : '2HG2' ,
      'HG23' : '3HG2' ,
      'HG21' : '1HG2' ,
      } ,
   } ,
'VAL': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CG2'  : { 'symbol' : 'C' , } ,
      '3HG2' : { 'symbol' : 'H' , } ,
      '3HG1' : { 'symbol' : 'H' , } ,
      'HB'   : { 'symbol' : 'H' , } ,
      '1HG1' : { 'symbol' : 'H' , } ,
      'CG1'  : { 'symbol' : 'C' , } ,
      '1HG2' : { 'symbol' : 'H' , } ,
      '2HG1' : { 'symbol' : 'H' , } ,
      '2HG2' : { 'symbol' : 'H' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( 'HB'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG1' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( '2HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( '3HG1', 'CG1'  ) : { 'order' : 1 , } ,
      ( 'CG2' , 'CB'   ) : { 'order' : 1 , } ,
      ( '1HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '2HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( '3HG2', 'CG2'  ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HG22' : '2HG2' ,
      'HG12' : '2HG1' ,
      'HG13' : '3HG1' ,
      'HG23' : '3HG2' ,
      'HG11' : '1HG1' ,
      'HG21' : '1HG2' ,
      } ,
   } ,
'TRP': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      'NE1'  : { 'symbol' : 'N' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      'CZ3'  : { 'symbol' : 'C' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      'CE3'  : { 'symbol' : 'C' , } ,
      'CH2'  : { 'symbol' : 'C' , } ,
      '2HH'  : { 'symbol' : 'H' , } ,
      '3HE'  : { 'symbol' : 'H' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      '3HZ'  : { 'symbol' : 'H' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'CZ2'  : { 'symbol' : 'C' , } ,
      'CE2'  : { 'symbol' : 'C' , } ,
      '2HZ'  : { 'symbol' : 'H' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( '1HD' , 'CD1'  ) : { 'order' : 1 , } ,
      ( 'NE1' , 'CD1'  ) : { 'order' : 1 , } ,
      ( '1HE' , 'NE1'  ) : { 'order' : 1 , } ,
      ( 'CE2' , 'NE1'  ) : { 'order' : 1 , } ,
      ( 'CZ2' , 'CE2'  ) : { 'order' : 1 , } ,
      ( '2HZ' , 'CZ2'  ) : { 'order' : 1 , } ,
      ( 'CH2' , 'CZ2'  ) : { 'order' : 2 , } ,
      ( '2HH' , 'CH2'  ) : { 'order' : 1 , } ,
      ( 'CZ3' , 'CH2'  ) : { 'order' : 1 , } ,
      ( '3HZ' , 'CZ3'  ) : { 'order' : 1 , } ,
      ( 'CE3' , 'CZ3'  ) : { 'order' : 2 , } ,
      ( '3HE' , 'CE3'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CE3'  ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CE2' , 'CD2'  ) : { 'order' : 2 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HZ3'  : '3HZ'  ,
      '1HZ'  : '3HZ'  ,
      'HZ2'  : '2HZ'  ,
      'HD1'  : '1HD'  ,
      'HE1'  : '1HE'  ,
      'HE3'  : '3HE'  ,
      'HH2'  : '2HH'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
'TYR': {
   'atoms' : {
      'N'    : { 'symbol' : 'N' , } ,
      'O'    : { 'symbol' : 'O' , } ,
      'HA'   : { 'symbol' : 'H' , } ,
      'CA'   : { 'symbol' : 'C' , } ,
      'H'    : { 'symbol' : 'H' , } ,
      'OXT'  : { 'symbol' : 'O' , } ,
      'C'    : { 'symbol' : 'C' , } ,
      '2HD'  : { 'symbol' : 'H' , } ,
      '2HE'  : { 'symbol' : 'H' , } ,
      '2HB'  : { 'symbol' : 'H' , } ,
      '1HD'  : { 'symbol' : 'H' , } ,
      '1HE'  : { 'symbol' : 'H' , } ,
      'CE1'  : { 'symbol' : 'C' , } ,
      'CD1'  : { 'symbol' : 'C' , } ,
      'HH'   : { 'symbol' : 'H' , } ,
      'CZ'   : { 'symbol' : 'C' , } ,
      '3HB'  : { 'symbol' : 'H' , } ,
      'CG'   : { 'symbol' : 'C' , } ,
      'CB'   : { 'symbol' : 'C' , } ,
      'OH'   : { 'symbol' : 'O' , } ,
      'CE2'  : { 'symbol' : 'C' , } ,
      'CD2'  : { 'symbol' : 'C' , } ,
      } ,
   'bonds' : {
      ( 'N'   , 'H'    ) : { 'order' : 1 , } ,
      ( 'N'   , 'CA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'HA'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'C'    ) : { 'order' : 1 , } ,
      ( 'C'   , 'O'    ) : { 'order' : 2 , } ,
      ( 'C'   , 'OXT'  ) : { 'order' : 1 , } ,
      ( '2HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( '3HB' , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CG'  , 'CB'   ) : { 'order' : 1 , } ,
      ( 'CD1' , 'CG'   ) : { 'order' : 2 , } ,
      ( '1HD' , 'CD1'  ) : { 'order' : 1 , } ,
      ( 'CE1' , 'CD1'  ) : { 'order' : 1 , } ,
      ( '1HE' , 'CE1'  ) : { 'order' : 1 , } ,
      ( 'CZ'  , 'CE1'  ) : { 'order' : 2 , } ,
      ( 'OH'  , 'CZ'   ) : { 'order' : 1 , } ,
      ( 'HH'  , 'OH'   ) : { 'order' : 1 , } ,
      ( 'CE2' , 'CZ'   ) : { 'order' : 1 , } ,
      ( '2HE' , 'CE2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CE2'  ) : { 'order' : 2 , } ,
      ( '2HD' , 'CD2'  ) : { 'order' : 1 , } ,
      ( 'CD2' , 'CG'   ) : { 'order' : 1 , } ,
      ( 'CA'  , 'CB'   ) : { 'order' : 1 , } ,
      } ,
   'aliases' : {
      'O1'   : 'O'    ,
      'O2'   : 'OXT'  ,
      'HN'   : 'H'    ,
      'OT'   : 'OXT'  ,
      'OT2'  : 'OXT'  ,
      'OT1'  : 'O'    ,
      'HB2'  : '2HB'  ,
      'HB3'  : '3HB'  ,
      'HB1'  : '3HB'  ,
      'HD1'  : '1HD'  ,
      'HD2'  : '2HD'  ,
      'HE1'  : '1HE'  ,
      'HE2'  : '2HE'  ,
      '1HB'  : '3HB'  ,
      } ,
   } ,
}
